



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mysql优化器在统计全表扫描的代价时的方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mysql优化器在统计全表扫描的代价时的方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 02:50:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>innodb 的聚集索引 的叶子结点 存放的 是 索引值以及数据页的偏移量</p>
<p>那么在计算全表扫描的代价是怎么计算的呢？</p>
<p>我们知道代价 为 cpu代价+io代价</p>
<p>cpu代价 就是 每5条记录比对 计算一个代价 (这里的记录并不是我们数据记录，而是索引记录)<strong> 是数据记录个数</strong></p>
<p>又是如何取出全表的总记录呢 (即全表的总索引记录)</p>
<p>具体方法是 通过索引能拿到叶子结点的page数，page页默认16K ，那么总容量为 leaf page num * 16k</p>
<p>再计算这个索引的长度，因为索引可能是由多个字段构成，因此要遍历，假设为 m</p>
<p>total_records = leaf page num * 16k /m 就是 索引记录个数了，<strong> 一条聚焦索引记录对应一条数据记录，所以这里是总的记录数</strong></p>
<p><strong>还是有问题 这个leaf page是数据页，而m是主键的长度，上面的total_records计算出来的结果 并不是准确的记录个数，按理说m为一条记录的长度，但代码里是主键的长度</strong></p>
<p>那么cpu cost 就是 total_records/5+1</p>
<p>　　io cost 就是&nbsp;&nbsp;(double) (prebuilt-&gt;table-&gt;stat_clustered_index_size(聚簇索引叶页面数);</p>
<div>
<pre class="prettyprint linenums">/******************************************************************//**<br />
Calculate the time it takes to read a set of ranges through an index<br />
This enables us to optimise reads for clustered indexes.<br />
@return    estimated time measured in disk seeks */<br />
UNIV_INTERN<br />
double<br />
ha_innobase::read_time(<br />
/*===================*/<br />
    uint    index,    /*!&lt; in: key number */<br />
    uint    ranges,    /*!&lt; in: how many ranges */<br />
    ha_rows rows)    /*!&lt; in: estimated number of rows in the ranges */<br />
{<br />
    ha_rows total_rows;<br />
    double    time_for_scan;

    if (index != table-&gt;s-&gt;primary_key) {<br />
        /* Not clustered */<br />
        return(handler::read_time(index, ranges, rows));<br />
    }

    if (rows &lt;= ) {

        return((double) rows);<br />
    }

    /* Assume that the read time is proportional to the scan time for all<br />
    rows + at most one seek per range. */

    time_for_scan = scan_time();

    //estimate_rows_upper_bound这里就是计算全表总记录的函数<br />
    if ((total_rows = estimate_rows_upper_bound()) &lt; rows) {

        return(time_for_scan);<br />
    }

    return(ranges + (double) rows / (double) total_rows * time_for_scan);<br />
}

/*********************************************************************//**<br />
Gives an UPPER BOUND to the number of rows in a table. This is used in<br />
filesort.cc.<br />
@return    upper bound of rows */<br />
UNIV_INTERN<br />
ha_rows<br />
ha_innobase::estimate_rows_upper_bound(void)<br />
/*======================================*/<br />
{<br />
    dict_index_t*    index;<br />
    ulonglong    estimate;<br />
    ulonglong    local_data_file_length;<br />
    ulint        stat_n_leaf_pages;

    //取得该表的第一个索引，就是聚集索引<br />
    index = dict_table_get_first_index(prebuilt-&gt;table);

    //聚焦索引的叶子结点个数<br />
    stat_n_leaf_pages = index-&gt;stat_n_leaf_pages;

    //大小为 叶子结点个数*16k<br />
    local_data_file_length = ((ulonglong) stat_n_leaf_pages) * UNIV_PAGE_SIZE;

    /* Calculate a minimum length for a clustered index record and from<br />
    that an upper bound for the number of rows. Since we only calculate<br />
    new statistics in row0mysql.c when a table has grown by a threshold<br />
    factor, we must add a safety factor 2 in front of the formula below. */

    //计算这个聚集索引的大小<br />
    // 2* 总叶子个数*16K / 聚焦索引大小 得到聚集索引记录个数<br />
    estimate =  * local_data_file_length /<br />
                     dict_index_calc_min_rec_len(index);

    DBUG_RETURN((ha_rows) estimate);<br />
}

/*********************************************************************//**<br />
Calculates the minimum record length in an index. */<br />
UNIV_INTERN<br />
ulint<br />
dict_index_calc_min_rec_len(<br />
/*========================*/<br />
    const dict_index_t*    index)    /*!&lt; in: index */<br />
{<br />
    ulint    sum    = ;<br />
    ulint    i;

    //记录为compack 紧凑模式，因为有可能这个索引是由多个字段组成，要遍历，求出总字节数<br />
    ulint    comp    = dict_table_is_comp(index-&gt;table);

    if (comp) {<br />
        ulint nullable = ;<br />
        sum = REC_N_NEW_EXTRA_BYTES;<br />
        for (i = ; i &lt; dict_index_get_n_fields(index); i++) {<br />
            const dict_col_t*    col<br />
                = dict_index_get_nth_col(index, i);<br />
            ulint    size = dict_col_get_fixed_size(col, comp);<br />
            sum += size;<br />
            if (!size) {<br />
                size = col-&gt;len;<br />
                sum += size &lt;  ?  : ;<br />
            }<br />
            if (!(col-&gt;prtype &amp; DATA_NOT_NULL)) {<br />
                nullable++;<br />
            }<br />
        }

        /* round the NULL flags up to full bytes */<br />
        sum += UT_BITS_IN_BYTES(nullable);

        return(sum);<br />
    }<br />
}</pre>
</div>
<h2>结构体dict_index_t</h2>
<div>
<pre class="prettyprint linenums">/** InnoDB B-tree index */<br />
typedef struct dict_index_struct dict_index_t;

/** Data structure for an index.  Most fields will be<br />
initialized to 0, NULL or FALSE in dict_mem_index_create(). */<br />
struct dict_index_struct{<br />
    index_id_t    id;    /*!&lt; id of the index */<br />
    mem_heap_t*    heap;    /*!&lt; memory heap */<br />
    const char*    name;    /*!&lt; index name */<br />
    const char*    table_name;/*!&lt; table name */<br />
    dict_table_t*    table;    /*!&lt; back pointer to table */ //<br />
#ifndef UNIV_HOTBACKUP<br />
    unsigned    space:;<br />
                /*!&lt; space where the index tree is placed */<br />
    unsigned    page:;/*!&lt; index tree root page number */<br />
#endif /* !UNIV_HOTBACKUP */<br />
    unsigned    type:DICT_IT_BITS;<br />
                /*!&lt; index type (DICT_CLUSTERED, DICT_UNIQUE,<br />
                DICT_UNIVERSAL, DICT_IBUF, DICT_CORRUPT) */<br />
#define MAX_KEY_LENGTH_BITS 12<br />
    unsigned    trx_id_offset:MAX_KEY_LENGTH_BITS;<br />
                /*!&lt; position of the trx id column<br />
                in a clustered index record, if the fields<br />
                before it are known to be of a fixed size,<br />
                0 otherwise */<br />
#if (1&lt;&lt;MAX_KEY_LENGTH_BITS) &lt; MAX_KEY_LENGTH<br />
# error (&lt;&lt;MAX_KEY_LENGTH_BITS) &lt; MAX_KEY_LENGTH<br />
#endif<br />
    unsigned    n_user_defined_cols:;<br />
                /*!&lt; number of columns the user defined to<br />
                be in the index: in the internal<br />
                representation we add more columns */<br />
    unsigned    n_uniq:;/*!&lt; number of fields from the beginning<br />
                which are enough to determine an index<br />
                entry uniquely */<br />
    unsigned    n_def:;/*!&lt; number of fields defined so far */<br />
    unsigned    n_fields:;/*!&lt; number of fields in the index */<br />
    unsigned    n_nullable:;/*!&lt; number of nullable fields */<br />
    unsigned    cached:;/*!&lt; TRUE if the index object is in the<br />
                dictionary cache */<br />
    unsigned    to_be_dropped:;<br />
                /*!&lt; TRUE if this index is marked to be<br />
                dropped in ha_innobase::prepare_drop_index(),<br />
                otherwise FALSE. Protected by<br />
                dict_sys-&gt;mutex, dict_operation_lock and<br />
                index-&gt;lock.*/<br />
    dict_field_t*    fields;    /*!&lt; array of field descriptions */<br />
#ifndef UNIV_HOTBACKUP<br />
    UT_LIST_NODE_T(dict_index_t)<br />
            indexes;/*!&lt; list of indexes of the table */<br />
    btr_search_t*    search_info; /*!&lt; info used in optimistic searches */<br />
    /*----------------------*/<br />
    /** Statistics for query optimization */<br />
    /* @{ */<br />
    ib_int64_t*    stat_n_diff_key_vals;<br />
                /*!&lt; approximate number of different<br />
                key values for this index, for each<br />
                n-column prefix where n &lt;=<br />
                dict_get_n_unique(index); we<br />
                periodically calculate new<br />
                estimates */<br />
    ib_int64_t*    stat_n_non_null_key_vals;<br />
                /* approximate number of non-null key values<br />
                for this index, for each column where<br />
                n &lt; dict_get_n_unique(index); This<br />
                is used when innodb_stats_method is<br />
                "nulls_ignored". */<strong><br />
    ulint        stat_index_size;<br />
                </strong><strong>/*!&lt; approximate index size in<br />
                database pages */</strong><br />
    <strong>ulint        stat_n_leaf_pages;<br />
              </strong>  <strong>/*!&lt; approximate number of leaf pages in the<br />
                index tree */</strong><br />
    /* @} */<br />
    rw_lock_t    lock;    /*!&lt; read-write lock protecting the<br />
                upper levels of the index tree */<br />
    trx_id_t    trx_id; /*!&lt; id of the transaction that created this<br />
                index, or 0 if the index existed<br />
                when InnoDB was started up */<br />
#endif /* !UNIV_HOTBACKUP */<br />
#ifdef UNIV_BLOB_DEBUG<br />
    mutex_t        blobs_mutex;<br />
                /*!&lt; mutex protecting blobs */<br />
    void*        blobs;    /*!&lt; map of (page_no,heap_no,field_no)<br />
                to first_blob_page_no; protected by<br />
                blobs_mutex; @see btr_blob_dbg_t */<br />
#endif /* UNIV_BLOB_DEBUG */<br />
#ifdef UNIV_DEBUG<br />
    ulint        magic_n;/*!&lt; magic number */<br />
/** Value of dict_index_struct::magic_n */<br />
# define DICT_INDEX_MAGIC_N<br />
#endif<br />
};</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2y2rw8.html">angularJs指令深度分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8krrz6q.html">Asp&period;Net WebForm和MVC同样优秀！</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrjyeq.html">PHP 短连接生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903rk49.html">Remark</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e0zr9.html">Uncaught SyntaxError&colon; Unexpected end of input</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1vgz8.html">JAVA操作properties文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj1r149.html">X509Certificate2 本地正常，放到线上内部错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojdkxlq.html">游戏客户端嵌入页面出白边bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pmgln8.html">浅谈SQL Server 对于内存的管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y3egw8.html">hdu4027 开方，记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4jm69.html">详解css3弹性盒模型（Flexbox）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojeyelq.html">openstack基础框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge2ox08.html">记录基于VMware虚拟机&comma; Linux7&period;2下外部主机访问配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rv2p49.html">模糊查询出list</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ry5l49.html">EasyUI中使用textbox赋值，setValue和setText顺序问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e43xem9.html">操作系统口令认证，sysdba本地登录需要输入密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gl6jzq.html">非root用户如何使用docker命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rngpxmq.html">荔枝FM 字体文件 IconFontTextView</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3z4e9.html">C&num;访问MySQL数据库帮助类</a>
		</li>
						<li><a href="https://www.batexi.com/a/953m22v8.html">URAL 1741 Communication Fiend</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/953w5068.html">硬件GPIO&comma;UART&comma;I2C&comma;SPI电路图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emjpgj9.html">为什么c&plus;&plus;中返回成员变量的指针，会破坏了封装？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7edm5e9.html">mysql CONCAT用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlwjjr9.html">json、JSONObject、JSONArray的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmlzm09.html">Unit Testing of Spring MVC</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk3oed8.html">51Nod 1376 最长递增子序列的数量 &lpar;DP&plus;BIT&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpgjz79.html">Memcached 应用场景</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvgv2gq.html">&amp;quot&semi;请求被中止&colon; 未能创建 SSL&sol;TLS 安全通道&amp;quot&semi;解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvekerj9.html">python正则表达式转义注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pdm23q.html">queued frame 造成图形性能卡顿</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
